/*
 * file: XxBase.cpp
 *
 * This file is part of the XxStdLib library which is developed to support
 * the development of NetStreamer. This file is distributed under the
 * GNU GENERAL PUBLIC LICENSE, see the accompanying COPYING file.
 *
 * Copyright (C) 1997 Rolf Fokkens
 *
 */

#include <iostream.h>
#include <malloc.h>

#include "XxBase.h"
#include "BiLink.h"
#include "XxAutoInit.h"

static XxBase::XxBaseSet::SetOwner *pRemoveOwner = NULL;

class InitClass {
private:
    int Dummy;
public:
    InitClass (void) {
        XxBase::Init ();
    };
};

AUTOINIT InitClass InitObject;

void XxBase::Init (void)
{
    if (pRemoveOwner == NULL) {
        pRemoveOwner   = new XxBase::XxBaseSet::SetOwner;

        AUTOINIT_TRACE ("XxBase::Init");
    };
};

XxBase::XxBase (void)
    : RemoveMember   (this)
{
};

XxBase::~XxBase (void)
{
};

long XxBase::GetAllocMem (void)
{
    struct mallinfo     mInfo;

    mInfo = mallinfo ();

    return mInfo.uordblks;
};

void XxBase::CleanupWasteBasket (void)
{
    XxBase *pBase;

    for (;;) {
        pBase = pRemoveOwner->GetFirst ();
        if (pBase == NULL) break;
        delete pBase;
    };
};

void XxBase::Remove (void)
{
   RemoveMember.Attach (*pRemoveOwner);
};

